signature ABSYN =
   sig
      include SYN
      datatype absyn = nullary of tv 
                     | unary of set | binary of rel 
      val toString : absyn -> string
   end

structure Absyn : ABSYN = 
   struct
      open PeirceTerm     
      datatype absyn = nullary of tv 
                     | unary of set | binary of rel 
      fun toString (unary s) = StoString s
        | toString (binary s) = RtoString s
        | toString (nullary s) = TtoString s
   end

