structure PersonenU = 
  struct
    datatype element = a | b | c | d | e | f | g | h | m | n | s | w | p
    val elements = [a,b,c,d,e,f,g,h,m,n,w,s]

    exception NoValue

    fun ConS "arbeiten"  = [a,e]
      | ConS "gesund"    = [a,d]
      | ConS "Anna"      = [a]
      | ConS "Maria"     = [m]
      | ConS "Dieter"    = [d]
      | ConS "Emil"      = [e]
      | ConS "Grete"     = [g]
      | ConS "Hans"      = [h]
      | ConS "Frau"      = [a,g,m]
      | ConS "Mann"      = [d,e,h]
      | ConS "Student"   = [a,e]
      | ConS "Stadt"     = [w,n]
      | ConS "Rom"      = [w]
      | ConS "Madrid"    = [n]
      | ConS "Spanien"   = [s]
      | ConS "Italien"   = [p]
      | ConS _           = raise NoValue
                                 
    fun ConR "in"        = [(w,p),(n,s)]
      | ConR "kennen"    = [(a,b),(b,c)]
      | ConR "lieben"    = [(b,d),(c,e),(b,a),(a,a),(e,a),(h,g)]
      | ConR "begrüßen"  = [(a,m),(a,g),(m,a)]
      | ConR "Geschwister" = 
        let 
            val gs = [(a,d),(a,m),(a,g),(m,g),(g,d),(m,d)]
        in 
            gs @ (map (fn (x,y) => (y,x)) gs) 
        end
      | ConR "Bruder"    = [(d,a),(d,g),(d,m)]
      | ConR "Schwester" = [(m,a),(a,m),(g,a),(a,g),(m,g),(g,m)]
      | ConR "Nachbar"   = [(d,e),(e,a)]
      | ConR "Hauptstadt"= [(n,s),(w,p)]
      | ConR "älter"     = [(d,a),(d,e),(a,e)]
      | ConR _           = raise NoValue
end

structure Personen = Peirce(PersonenU)

structure NL1 : PARSE = Parse(structure Algebra = Personen)
